# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorarch: %global perl_vendorarch %(eval "`perl -V:installvendorarch`"; echo $installvendorarch)}

Summary:	Interface to the DNS resolver
Name:		perl-Net-DNS
Version:	0.68
Release:	1.0.cf.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
Url:		http://www.net-dns.org/
Source0:	http://www.net-dns.org/download/Net-DNS-%{version}.tar.gz
Source1:	perl-module-version-filter
Patch0:		Net-DNS-0.66-UTF8.patch
Patch1:		Net-DNS-0.68-useless-constant.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(Digest::BubbleBabble)
BuildRequires:	perl(Digest::HMAC)
BuildRequires:	perl(Digest::SHA)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(IO::Socket::INET6)
BuildRequires:	perl(Test::Pod)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Don't "provide" private Perl libs
%global __provides_exclude ^DNS\\.so

%description
Net::DNS is a collection of Perl modules that act as a Domain Name
System (DNS) resolver. It allows the programmer to perform DNS queries
that are beyond the capabilities of gethostbyname and gethostbyaddr.

The programmer should be somewhat familiar with the format of a DNS
packet and its various sections. See RFC 1035 or DNS and BIND (Albitz
& Liu) for details.

%package Nameserver
Summary:	DNS server for Perl
Group:		Development/Libraries

%description Nameserver
Instances of the "Net::DNS::Nameserver" class represent DNS server
objects.

%prep
%setup -q -n Net-DNS-%{version}

# fix encoding of ChangeLog
%patch0 -p1

# suppress "useless use of constant" verbose warnings with perl < 5.8.5
%if %(perl -e 'print $] >= 5.008005 ? 0 : 1;')
%patch1 -p1
%endif

%build
perl Makefile.PL --online-tests --IPv6-tests \
	INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -a -size 0 -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
chmod -R u+w %{buildroot}

# Auto provides aren't clever enough for what Net::DNS does
%global filter_chain | perl -n -s %{SOURCE1} -perllib=%{buildroot}%{perl_vendorarch}
%if 0%{?__perllib_provides:1}
%global perllib_filt /bin/sh -c "%{__perllib_provides} %{filter_chain}"
%define __perllib_provides %{perllib_filt}
%else
%global perl_filt /bin/sh -c "%{__perl_provides} %{filter_chain}"
%define __perl_provides %{perl_filt}
%endif

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README* TODO
%{perl_vendorarch}/Net/
%{perl_vendorarch}/auto/Net/
%{_mandir}/man3/Net::DNS.3pm*
%{_mandir}/man3/Net::DNS::*
# perl-Net-DNS-Nameserver
%exclude %{perl_vendorarch}/Net/DNS/Nameserver.pm
%exclude %{_mandir}/man3/Net::DNS::Nameserver.3pm*
# Win32 files
%exclude %{perl_vendorarch}/Net/DNS/Resolver/Cygwin.pm
%exclude %{_mandir}/man3/Net::DNS::Resolver::Cygwin.3*
%exclude %{perl_vendorarch}/Net/DNS/Resolver/Win32.pm
%exclude %{_mandir}/man3/Net::DNS::Resolver::Win32.3*

%files Nameserver
%defattr(-,root,root,-)
%{perl_vendorarch}/Net/DNS/Nameserver.pm
%{_mandir}/man3/Net::DNS::Nameserver.3pm*

%changelog
* Wed Feb  1 2012 Paul Howarth <paul@city-fan.org> 0.68-1.0.cf
- Update to 0.68
  - CPAN RT#72314: Let a Net::DNS::Nameserver bind on
    Net::DNS::Nameserver::DEFAULT_ADDR as a last resort
  - Fix to suppress false warnings about subroutine profiles on ancient
    versions of perl
  - Fix to avoid constants with value undef, which prevents unwanted code from
    being optimized away on ancient versions of perl
  - Fix code error in PTR.pm, canonical RDATA not downcased
  - Enhancement to clarify the function of parse and data methods, by renaming
    them to decode and encode respectively
  - Feature IDN query support: Queries for domain names containing non-ASCII
    characters are now possible on Unicode platforms with CPAN Net::LibIDN
    installed
  - Introduction of Mailbox.pm module that will be used in the future to
    represent RDATA components containing DNS coded RFC822 mailbox addresses
  - Introduction of Text.pm module that will be used in the future to represent
    RDATA components containing text
- Update patch to suppress "useless use of constant in void context" warnings

* Mon Nov  7 2011 Paul Howarth <paul@city-fan.org> 0.67-1.0.cf
- Update to 0.67 (lots of bugfixes and enhancements - see Changes for details)
- Drop now-redundant build requirement perl(Net::IP)
- Add patch to suppress highly verbose "useless use of constant in void
  context" warnings with perl < 5.8.5

* Tue Jul  5 2011 Paul Howarth <paul@city-fan.org> 0.66-4.0.cf
- Rebuild for perl 5.14.1 in Rawhide
- Fix provides filter to work with rpm 4.9 properly
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun  3 2011 Paul Howarth <paul@city-fan.org> 0.66-3.0.cf
- Use patch rather than iconv to fix ChangeLog encoding
- Nobody else likes macros for commands

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 0.66-2.1.cf
- Rebuild for perl 5.12.1 in Rawhide

* Fri May  7 2010 Paul Howarth <paul@city-fan.org> 0.66-2.0.cf
- Fix dist tag to work with RHEL6 Beta

* Wed Dec 30 2009 Paul Howarth <paul@city-fan.org> 0.66-1.0.cf
- Update to 0.66 (lots of bugfixes and enhancements - see Changes for details)
- BR: perl(Digest::SHA)
- Dist tag for Rawhide no longer needs special-casing

* Tue Sep 22 2009 Paul Howarth <paul@city-fan.org> 0.65-1.2.cf
- Use %%{?perl_default_filter} for provides filtering

* Mon Mar  2 2009 Paul Howarth <paul@city-fan.org> 0.65-1.1.cf
- Filter out unwanted provides for perl shared objects
- Update to SLES-compatible dist tag macros

* Tue Jan 27 2009 Paul Howarth <paul@city-fan.org> 0.65-1.0.CF
- Update to 0.65

* Thu Jan 22 2009 Paul Howarth <paul@city-fan.org> 0.64-1.0.CF
- Update to 0.64
- Tweak dist tag macros to work on Rawhide with three-part releasenum
- Use Makefile.PL options to supply answers to build-time questions instead of
  piping in answers from a separate shell

* Mon Feb 11 2008 Paul Howarth <paul@city-fan.org> 0.63-1.0.CF
- Update to 0.63

* Wed Jan  2 2008 Paul Howarth <paul@city-fan.org> 0.62-1.0.CF
- Update to 0.62

* Fri Dec 21 2007 Paul Howarth <paul@city-fan.org> 0.61-4.0.CF
- Split Nameserver.pm into subpackage, per recommendation from
  upstream maintainer Dick Franks.
  - Separates the server bits from the client bits.
  - Removes the dependancy on perl(Net::IP) from perl-Net-DNS
- Recode Changes file as UTF8
- Add buildreq perl(IO::Socket::INET6) for extra test cover
- Don't package Cygwin resolver

* Thu Aug  2 2007 Paul Howarth <paul@city-fan.org> 0.61-1
- update to 0.61
- clarify license as GPL+ (GPL v1 or later) or Artistic (same as perl)

* Mon Jun 25 2007 Paul Howarth <paul@city-fan.org> 0.60-1
- update to 0.60

* Tue Jun  5 2007 Paul Howarth <paul@city-fan.org> 0.59-3
- fix dist tag for Fedora 7 onwards
- add buildreq perl(ExtUtils::MakeMaker)

* Tue Oct  3 2006 Paul Howarth <paul@city-fan.org> 0.59-2
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Tue Sep 19 2006 Paul Howarth <paul@city-fan.org> 0.59-1
- update to 0.59
- fix argument order for find with -depth

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> 0.58-2
- Fix distribution tags for development releases

* Wed Jul  5 2006 Paul Howarth <paul@city-fan.org> 0.58-1
- Update to 0.58
- Define %%{__id_u} in a more portable way

* Mon Feb 27 2006 Paul Howarth <paul@city-fan.org> 0.57-1
- Update to 0.57
- inet6 test now fixed upstream and doesn't need patching

* Tue Feb 21 2006 Paul Howarth <paul@city-fan.org> 0.56-1
- Update to 0.56
- Support building on CentOS
- Fix inet6 test, broken if IPV6 support not enabled

* Wed Dec 14 2005 Paul Howarth <paul@city-fan.org> 0.55-1
- Update to 0.55

* Thu Dec  8 2005 Paul Howarth <paul@city-fan.org> 0.54-1
- Update to 0.54
- Remove macros __perl_version and __perl_package
- Remove buildroot unconditionally in %%clean and %%install
- Simplify distribution-detection
- Use sed to modify MANIFEST rather than scripting arpund grep
- Simplify compiler optmization flag setup
- Don't use macros in paths for build-time commands, hardcode them instead
- Own directories properly
- Add buildreqs perl(Test::Pod) and perl(Digest::BubbleBabble) for tests

* Tue Jul 26 2005 Paul Howarth <paul@city-fan.org> 0.53-1
- Update to 0.53

* Mon Jul  4 2005 Paul Howarth <paul@city-fan.org> 0.52-1
- Update to 0.52

* Fri Jun 24 2005 Paul Howarth <paul@city-fan.org> 0.51_02-1
- Update to 0.51_02
- Rewrite spec file in (mainly) Fedora Extras style
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Add perl(Net::IP) buildrequire

* Fri Apr  1 2005 Paul Howarth <paul@city-fan.org> 0.49-1
- Update to 0.49

* Tue Aug 24 2004 Paul Howarth <paul@city-fan.org> 0.48-1
- Update to 0.48
- Tidy up of spec file

* Wed Apr 14 2004 Paul Howarth <paul@city-fan.org> 0.47-1
- Update to 0.47.
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuilt from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Fri Feb 27 2004 Paul Howarth <paul@city-fan.org> 0.46-1
- Update to 0.46

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 0.45-2
- Unified spec file for Red Hat and Fedora Core

* Fri Jan 09 2004 Paul Howarth <paul@city-fan.org> 0.45-1.fc1
- update to 0.45
- removed buildarch: noarch as there is now compiled C in this module
- remove Win32.pm that creates bad dependency
- updated specfile to use more macros and add fedora-release dependency

* Mon Oct 20 2003 Chip Turner <cturner@redhat.com> 0.31-3.2
- fix interactive build issue

* Mon Jan 27 2003 Chip Turner <cturner@redhat.com>
- version bump and rebuild

* Tue Dec 10 2002 Chip Turner <cturner@redhat.com>
- update to latest version from CPAN

* Tue Aug  6 2002 Chip Turner <cturner@redhat.com>
- automated release bump and build

* Tue Aug  6 2002 Chip Turner <cturner@localhost.localdomain>
- update to 0.26

* Thu Jun 27 2002 Chip Turner <cturner@redhat.com>
- description update

* Sat Jun 15 2002 cturner@redhat.com
- Specfile autogenerated

